<ui:composition template="/WEB-INF/templates/layout.xhtml"
	xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="http://xmlns.jcp.org/jsf/core"
	xmlns:h="http://xmlns.jcp.org/jsf/html"
	xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	xmlns:p="http://primefaces.org/ui"
	xmlns:c="http://java.sun.com/jsp/jstl/core">
	
	<ui:param name="title" value="Settings" />
		
	<ui:define name="content">
		<div class="layout-wrapper">
			<div class="layout">
				<div class="content-header">
					<h1>Profile settings</h1>
					<h5>You can change your info here.</h5>
				</div>
				<p:messages id="messages" globalOnly="true" showDetail="true">
					<p:autoUpdate />
				</p:messages>
				<div class="card details">
					<div class="image-wrapper">
						<p:graphicImage value="#{profilePicBacking.profilePic}"
							alt="profile picture"
							height="150"
							rendered="#{not empty settingsBacking.loggedInUser.profilePhoto}">
							<f:param name="userEmail" value="#{settingsBacking.email}" />	
						</p:graphicImage>
						<p:outputPanel rendered="#{empty settingsBacking.loggedInUser.profilePhoto}">
							<img src="https://avatars.dicebear.com/api/initials/#{settingsBacking.firstName} #{settingsBacking.lastName}.svg" 
									alt="profile-pic-placeholder"
									style="height: 150px"/>
						</p:outputPanel>
						<div class="upload-form">
							<h:form id="pictureUploadForm" enctype="multipart/form-data">
								<div class="file-upload">
									<p:fileUpload mode="simple" value="#{settingsBacking.profilePic}" />
								</div>
								<div>
									<p:commandButton value="Upload" action="#{settingsBacking.upload}" ajax="false" />
								</div>
							</h:form>
						</div>
					</div>
					<div class="settings p-grid p-formgrid ui-fluid">
						<h:form id="profile-settings" method="post" enctype="application/x-www-form-urlencoded">
							<div class="p-grid p-formgrid ui-fluid">
								<div class="p-field p-col">
									<p:outputLabel for="firstName" value="First name" />
									<p:inputText id="firstName" value="#{settingsBacking.firstName}" 
										required="true"
										requiredMessage="First name cannot be empty"
										validatorMessage="Please enter a valid name">
										<f:validateRegex pattern="^[A-Za-z ]+" />
										<p:clientValidator event="change" />
									</p:inputText>
									<small><p:message id="firstNameError" for="firstName" display="text" /></small>
								</div>
								<div class="p-field p-col">
									<p:outputLabel for="lastName" value="Last name" />
									<p:inputText id="lastName" value="#{settingsBacking.lastName}" 
										required="true"
										requiredMessage="Last name cannot be empty" 
										validatorMessage="Please enter a valid name">
										<f:validateRegex pattern="^[A-Za-z ]+" />
										<p:clientValidator event="change" />
									</p:inputText>
									<small><p:message id="lastNameError" for="lastName" display="text" /></small>
								</div>
							</div>
							<div class="p-field">
								<p:outputLabel for="username" value="Username" />
								<p:inputText id="username" value="#{settingsBacking.username}" 
									required="true"
									requiredMessage="Username cannot be empty">
									<p:clientValidator event="change" />
								</p:inputText>
								<small><p:message id="usernameError" for="username" display="text" /></small>
							</div>
							<div class="p-field">
								<p:outputLabel for="email" value="Email" />
								<p:inputText id="email" value="#{loggedInUser.email}" disabled="true" /> <!-- Email cant be modified since that is what we use to identify the user -->
							</div>
							<div class="p-field">
								<p:outputLabel for="password" value="Password" />
								<div class="input">
									<p:password 
										id="password"
										value="#{settingsBacking.password}"
										required="true"
										requiredMessage="Password cannot be empty"
										feedback="true"
										validatorMessage="Password has to be between 6 and 20 characters"
										placeholder="You can write your new password here">
										<f:validateLength minimum="6" maximum="20" />
										<p:clientValidator event="change" />
									</p:password>
									<small><p:message id="passwordError" for="password" display="text" /></small>
								</div>
							</div>
							<div class="btn-container">
								<p:commandButton id="btnUpdate" 
									value="Update" 
									action="#{settingsBacking.updateUser()}" 
									validateClient="true"
									update="@form"
									styleClass="form-button" />
								<p:linkButton id="btnCancel" value="Cancel" outcome="dashboard" styleClass="form-button btn-delete" />
							</div>
						</h:form>
					</div>
				</div>
			</div>
		</div>
	</ui:define>
</ui:composition>